"""
Wrapper for running maven-ish things for the rest of the deployment system.
"""
from invoke import env
import os

def mvn(c, t, *tasks, **kwargs):
    """
    Run Maven with the supplied tasks. Optional argument of modules= can
    be used to restrict Maven to building some specific modules.
    """
    modules = kwargs.pop('modules', [])
    profile = kwargs.pop('profile', "") or os.environ.get('CAPO_PROFILE')
    tasks = [t] + list(tasks)
    module_arg = "-pl {0} -am".format(','.join(modules)) if modules else ""
    print(f"Building {', '.join(modules)}")
    c.run(f"mvn {'-q' if env.quiet else ''} -DCAPO_PROFILE={profile} "
          f"-Dmaven.test.skip {module_arg} {' '.join(tasks)}",
          pty=True)  # this argument allows maven to write color output
